#include <iostream>
#include <list>
#include "studentas.h"
#include "kompiuteris.h"
#include "kompiuterisList.h"

using namespace std;

//------------------------------------------------------------
KompiuterisList::~KompiuterisList() {
   list<Kompiuteris*>::iterator vi;
   for (vi = pcList.begin();  vi != pcList.end();  vi++)
       delete (*vi);           // delete Kompiuteris objektus
       pcList.clear();         // delete Kompiuteris nuorodas (pointers)
}
//------------------------------------------------------------
void KompiuterisList::printSarasa() {
   cout << "****************************************************" << endl;
   pcList.sort(Palyginti());
   list<Kompiuteris*>::iterator vi = pcList.begin();

   for (;  vi != pcList.end();  vi++)
      (*vi)->printKompiuteris();
   cout << "****************************************************" << endl;
}
//------------------------------------------------------------
void KompiuterisList::iSarasa(std::string pcNr, std::string pavarde, std::string date)
{
  list<Kompiuteris*>::iterator i=pcList.begin();
  while((i!=pcList.end())&&((*i)->getKompiuteris()!=pcNr))
    i++;
  if(i==pcList.end())
  {
    Kompiuteris* g=new Kompiuteris(pcNr);
    g->iSarasa(pavarde, date);
    pcList.push_back(g);
  }
  else
    (*i)->iSarasa(pavarde, date);
}
//------------------------------------------------------------
void KompiuterisList::addToSarasas() {
   string pcNr;
   string pavarde;
   string data;
   cout << "Prie kokio kompiuterio dirbo studentas: ";
   cin >> pcNr;
   cout << "Studento pavarde: ";
   cin >> pavarde;
   cout << "Data (MMMM-mm-dd): ";
   cin >> data;
   list<Kompiuteris*>::iterator iter = pcList.begin();
      for (;  iter != pcList.end();  iter++) {
      string pcNrX = (*iter)->getKompiuteris();
         if (pcNrX == pcNr) {
            (*iter)->iSarasa(pavarde,data);
            break;
         }
      }
}
//------------------------------------------------------------
void KompiuterisList::printLaikotarpi() {
   string dataNuo;
   string dataIki;
   cout << "Nuo kada (MMMM-mm-dd): ";
   cin >> dataNuo;
   cout << "Iki kada (MMMM-mm-dd): ";
   cin >> dataIki;
   list<Kompiuteris*>::iterator iter = pcList.begin();
   for (;  iter != pcList.end();  iter++)
      (*iter)->pcPagalLaika(dataNuo, dataIki);
}
//------------------------------------------------------------
void KompiuterisList::printVienaSarasa(){
   string pcNr;
   cout << "Kurio kompiuterio sarasa parodyti: ";
   cin >> pcNr;
   list<Kompiuteris*>::iterator iter = pcList.begin();
   for (;  iter != pcList.end();  iter++) {
      string pcNrX = (*iter)->getKompiuteris();
      if (pcNrX == pcNr)
         (*iter)->printKompiuteris();
   }
}
//------------------------------------------------------------
